﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace Erettsegi23_Szamok
{
    class Feladvány
    {
        public string Kérdés { get; set; }
        public int Válasz { get; set; }
        public byte Pont { get; set; }
        public string Témakör { get; set; }

        public Feladvány(string s1, string s2)
        {
            Kérdés = s1;
            Válasz = int.Parse(s2.Split(' ')[0]);
            Pont = byte.Parse(s2.Split(' ')[1]);
            Témakör = s2.Split(' ')[2];
        }

        public byte Pontoz(string válasz)
        {
            return válasz == Válasz.ToString() ? Pont : (byte)0;
        }

        public override string ToString()
        {
            return String.Format("{0} {1} {2}", Pont, Válasz, Kérdés);
        }
    }

    class Szamok
    {
        static void Main()
        {
            Console.WriteLine("1. feladat: Beolvasás");
            string[] forrás = File.ReadAllLines("felszam.txt");
            List<Feladvány> feladványok = new List<Feladvány>();
            for (int i = 0; i < forrás.Length; i+=2) feladványok.Add(new Feladvány(forrás[i], forrás[i + 1]));

            Console.WriteLine("2. feladat: Az adatfájban {0} db feladat van!", feladványok.Count);

            Console.Write("3. feladat: Az adatfájban {0} db matematika feladat van", feladványok.Count(x => x.Témakör == "matematika"));
            foreach (var i in feladványok.Where(x => x.Témakör == "matematika").GroupBy(x => x.Pont).Select(g => new { Pont = g.Key, db = g.Count() }).OrderBy(x => x.Pont)) 
                Console.Write(", {0} pontot ér {1} feladat", i.Pont, i.db);
            Console.WriteLine(".");

            Console.WriteLine("4. feladat: Számértékek: {0}..{1}", feladványok.Min(x => x.Válasz), feladványok.Max(x => x.Válasz));

            Console.WriteLine("5. feladat: Témakörök:");
            foreach (var i in feladványok.GroupBy(x => x.Témakör).Select(g => g.Key )) Console.WriteLine("\t{0}",i);

            Console.Write("6. feladat: Milyen témakörből szeretnél kérdést kapni? ");
            string témakör = Console.ReadLine();
            Random r = new Random();
            var témakörFeladványai = feladványok.Where(x => x.Témakör == témakör).ToArray();
            var randomFeladvány = témakörFeladványai[r.Next(0, témakörFeladványai.Count())];
            Console.Write("{0} ",randomFeladvány.Kérdés);
            byte pont = randomFeladvány.Pontoz(Console.ReadLine());
            Console.WriteLine("A válasz {0} pontot ér.", pont);
            if (pont == 0) Console.WriteLine("A helyes válasz: {0}", randomFeladvány.Válasz);

            Console.WriteLine("7. feladat: tesztfel.txt");
            HashSet<Feladvány> f = new HashSet<Feladvány>();
            while (f.Count < 10) f.Add(feladványok[r.Next(0, feladványok.Count())]);
            List<string> ki = new List<string>(f.Select(x => x.ToString()).ToArray());
            ki.Add(String.Format("A feladatsorra osszesen {0} pont adhato.",f.Sum(x=>x.Pont)));
            File.WriteAllLines("tesztfel.txt", ki);

            Console.ReadKey();
        }
    }
}
